TARGET = mipsisa64r2-nlm-elf


ifeq ("$(BUILD_LINUXU)","1")

ifeq ("$(BUILD_LINUXU_SOCLIB)","1")
TARGET = mipsisa64r2nlm-linux
ABI = 32
else
TARGET = mipsisa64r2-nlm-linux
endif
CFLAGS += -DNLM_LINUXU
CFLAGS += -DNLM_ARCH_XLP -D_GNU_SOURCE -I$(NETOS_ROOT)/srcs/soclib
CPPFLAGS += -I$(NETOS_ROOT)/srcs/linuxu
opt-level = 2
endif

ifeq ("$(LE)", "1")
ENDIANNESS = -EL
EMUL = ltsmip
else
ENDIANNESS = -EB
EMUL = btsmip
endif


ifeq ("$(ABI)","64")
abi_flags = -mabi=64
LDFLAGS  += -melf64$(EMUL)
else

ifeq ("$(BUILD_LINUXU_SOCLIB)","1")
abi_flags = -mabi=32
else
abi_flags = -mabi=o64
endif

LDFLAGS  += -melf32$(EMUL)
endif

ASFLAGS  += $(abi_flags)
CFLAGS   += $(abi_flags)
CPPFLAGS += $(abi_flags)

AS       =  $(TARGET)-gcc
CC       =  $(TARGET)-gcc
CXX      =  $(TARGET)-g++
LD       =  $(TARGET)-ld
AR       =  $(TARGET)-ar
RANLIB   =  $(TARGET)-ranlib
OBJDUMP  =  $(TARGET)-objdump
NM       =  $(TARGET)-nm
OBJCOPY  =  $(TARGET)-objcopy
AWK      =  awk
STRIP    = $(TARGET)-strip

# By default, netos_lib will be compiled with debug symbols
# and will be stripped in the end to create two netos_libs,
# one with debug and another without debug
CFLAGS += -g3

HAL_FLAGS = -DNLM_HAL_NETOS

ifeq ("$(XLP_SIM)","1")
CFLAGS      += -DXLP_SIM -D__DYNAMIC_REENT__ -march=xlp -mhard-float $(ENDIANNESS)
CPPFLAGS    += -DXLP_SIM -D__DYNAMIC_REENT__ $(HAL_FLAGS) $(ENDIANNESS)
else
ifeq ("$(ABI)","64")
CFLAGS += -march=xlr -mabi=64 -msoft-float -D__DYNAMIC_REENT__
else
CFLAGS += -DPHOENIX_SIM=1 -march=xlr -mabi=o64 -msoft-float
endif
CFLAGS += -DNLM_BRIDGE_WKAROUND
endif #XLP_SIM


ifeq ("$(NEWLIB_VER)", "")
CFLAGS += -DNEWLIB_VER=117
else
CFLAGS += -DNEWLIB_VER=$(NEWLIB_VER)
endif # NEWLIB_VER

#
# Optimization and misc information to C compiler
#

ifeq ($(opt-level),)
  opt-level = 3
endif

CFLAGS += -O$(opt-level)

ifneq ($(unroll-loops),N)
  CFLAGS += -funroll-loops
endif

ifeq ($(inline-limit),)
  inline-limit = 20000
endif

CFLAGS += -finline-limit=$(inline-limit)
CFLAGS += -fomit-frame-pointer -mno-branch-likely

CFLAGS += -Wall -Werror

ifeq ("$(BUILD_LINUXU)","1")
CFLAGS += -G 0 -DNLM_HAL_LINUX_USER -pthread
else
CFLAGS += -G 0 -mno-gpopt $(HAL_FLAGS)
CFLAGS += -mno-abicalls -fno-pic -fno-common
endif

ASFLAGS += $(CFLAGS) -D__ASSEMBLY__

LINKFLAGS += -d -warn-common #--no-warn-mismatch

#
# header file locations
#

CPPFLAGS += -I$(NETOS_ROOT)/srcs/include -I$(NETOS_ROOT)/srcs/include/sys_shared  -I$(NETOS_INSTALL_DIR)/include
CPPFLAGS += -I$(HAL_DIR) -I$(FDT_DIR)/libfdt -I$(FDT_DIR)/libfdt/contrib
CPPFLAGS += -I. -I$(NETOS_ROOT)/srcs/usr/include/sys/

export AS CC CXX LD AR RANLIB OBJDUMP NM OBJCOPY AWK 
export NETOS_ROOT MAKE HAL_DIR FDT_DIR
export CPPFLAGS ASFLAGS CFLAGS LDFLAGS ABI 
