#ifndef _FDT_LOCAL_H
#define _FDT_LOCAL_H


/* Some defines for FDT
 */
#define MAX_PROP_LEN     	256
#define CMDLINE_SIZE           	2048

/* Macros for accessing FDT
 */
enum {
        PROP_STR,
        PROP_INT32
};

extern int get_fdt_prop(void *fdt, const char* node_path, const char *prop, void *prop_buf, int type);

#define GET_FPROP(fdt, path, prop, prop_buf)             \
	if (get_fdt_prop(fdt, path, prop, prop_buf, PROP_INT32) != 0) {	\
		fprintf(stderr, "Get prop (%s) failed on %s\n Aborting", prop, path); \
		return -1;                                  \
	}

#define GET_FPROP_STR(fdt, path, prop, prop_buf)                      \
        if (get_fdt_prop(fdt, path, prop, prop_buf, PROP_STR) != 0) {                 \
		fprintf(stderr, "Get prop (%s) failed on %s! Aborting !\n", prop, path);    \
                return -1;                                                                                 \
        }


#endif  /* FDT_LOCAL_H */
