/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef __NETOS_PERFCTR_H
#define __NETOS_PERFCTR_H

#include "mips-exts.h"

#define PERF_CTR_FETCHED_INS						0
#define PERF_CTR_L1_ICM								1
#define PERF_CTR_ICU_MISS_Q_ENTRY_ALLOC				2
#define PERF_CTR_ICU_MISS_Q_ENTRY_OCCUPIED			3
#define PERF_CTR_ICU_MISS_Q_MERGES					4
#define PERF_CTR_ICU_MISS_Q_FULL_REJECTS			5
#define PERF_CTR_ICACHE_PARITY_ERR					6
#define PERF_CTR_ICU_INS_FETCHPIPE_BUBBLES_REQS		7
#define PERF_CTR_uTLB_IM							8
#define PERF_CTR_MMU_uTLB_MISSREQS_REJECTS			9
#define PERF_CTR_NUM_THREADS						10
#define PERF_CTR_TLB_OVERLAP_ENTRIES_REMOVES		11
#define PERF_CTR_IFU_PERF_SLEEP						12
#define PERF_CTR_IFU_PERF_REPLAYCYCLES				13
#define PERF_CTR_IFU_PERF_OP_VLD					14
#define PERF_CTR_IFU_REPLAY_BUF_FULL				15
#define PERF_CTR_BR_PRED_TAKEN				16
#define PERF_CTR_INS_RET					17
#define PERF_CTR_BR_INS						18
#define PERF_CTR_BR_TAKEN					19
#define PERF_CTR_BRJMP_INS					20
#define PERF_CTR_BRJMP_FLUSH				21
#define PERF_CTR_JR_INS						22
#define PERF_CTR_JR_FLUSH					23
#define PERF_CTR_BRJMP_TARGET_MISMATCH		24
#define PERF_CTR_INT						25
#define PERF_CTR_EXCEPTIONS					26
#define PERF_CTR_REPLAYFLUSH				27
#define PERF_CTR_REPLAYFLUSH_LDUSE			28
#define PERF_CTR_REPLAYFLUSH_ALU			29
#define PERF_CTR_WRB_FLUSH					30
#define PERF_CTR_PREF_OP					31
#define PERF_CTR_ST_OP						32
#define PERF_CTR_LD_OP						33
#define PERF_CTR_PREF_HIT					34
#define PERF_CTR_LD_HIT						35
#define PERF_CTR_ST_HIT						36
#define PERF_CTR_ST_UPG						37
#define PERF_CTR_MEM_HIT					38
#define PERF_CTR_MEM_REF					39
#define PERF_CTR_RDQ_ABRT					40
#define PERF_CTR_WRQ_ABRT					41
#define PERF_CTR_ST_ABRT					42
#define PERF_CTR_FLUSH						43
#define PERF_CTR_uTLB_DM					44
#define PERF_CTR_VICTREQ					45
#define PERF_CTR_STALL						46
#define PERF_CTR_SNPUPGFAIL_SN3P			47
#define PERF_CTR_SNP_XFER					48
#define PERF_CTR_SNP_HIT					49
#define PERF_CTR_SNP_OP_SN3P				50
#define PERF_CTR_RDQ_ALLOC_ENT0				51
#define PERF_CTR_RDQ						52
#define PERF_CTR_CYC_CNT					63

#define PERF_CTR_EVENT0        0
#define PERF_CTR_EVENT0_VALUE  1
#define PERF_CTR_EVENT1        2
#define PERF_CTR_EVENT1_VALUE  3

#define perf_ctr_start(event, ctr) write_32bit_cp0_register_sel(CP0_PERF_CTR, (0x80002002|((event)<<5)), ctr)
#define perf_ctr_start_this_thread(event, ctr) \
	write_32bit_cp0_register_sel ( CP0_PERF_CTR, \
	                               (0x00000002 | ((event)<<5) | ((processor_id() & 3) << 11) ), \
								   ctr \
								 )
#define perf_ctr_stop(ctr) write_32bit_cp0_register_sel(CP0_PERF_CTR, 0x80002000, ctr)
#define perf_ctr_reset(ctr) write_32bit_cp0_register_sel(CP0_PERF_CTR, 0, ctr)
#define perf_ctr_read(ctr) read_32bit_cp0_register_sel(CP0_PERF_CTR, ctr)

#endif
