/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _PHNX_INFO_H
#define _PHNX_INFO_H

static struct {
    char *name;
    int id;
    int has_cores;
    int has_gmac;
    int has_xgmac;
    int has_spi4;
    int has_ht;
    int has_sram;
    int has_pcix;
    int has_cmp;
    int has_usb;
    int has_pcie;
    int has_dram;
    int banks;
} phnx_processors[] = {
    {
    "XLR732",  0,   8, 4, 1, 1, 1, 1, 1, 0, 0, 0, 1,8}, {
    "XLR732", 0x0b, 8, 4, 1, 1, 1, 1, 1, 0, 0, 0, 1,8}, {
    "XLR716", 0x0a, 4, 4, 1, 1, 1, 1, 1, 0, 0, 0, 1,4}, {
    "XLR532", 0x09, 8, 4, 0, 0, 1, 0, 1, 0, 0, 0, 1,8}, {
    "XLR516", 0x08, 4, 4, 0, 0, 1, 0, 1, 0, 0, 0, 1,4}, {
    "XLR508", 0x07, 2, 4, 0, 0, 1, 0, 1, 0, 0, 0, 1,2}, {
    "XLR308", 0x06, 2, 3, 0, 0, 0, 0, 1, 0, 0, 0, 1,2}, {
    "XLS608", 0x80, 2, 8, 0, 0, 0, 0, 0, 1, 1, 1, 1,4}, {
    "XLS408", 0x88, 2, 6, 0, 0, 0, 0, 0, 1, 1, 1, 1,4}, {
    "XLS404", 0x8c, 1, 6, 0, 0, 0, 0, 0, 1, 1, 1, 1,2}, {
    "XLS208", 0x8e, 2, 4, 0, 0, 0, 0, 0, 0, 1, 1, 0,2}, {
    "XLS204", 0x8f, 1, 4, 0, 0, 0, 0, 0, 0, 1, 1, 0,1}, {
    "XLS108", 0xce, 2, 3, 0, 0, 0, 0, 0, 0, 1, 1, 0,2}, {
    "XLS104", 0xcf, 1, 3, 0, 0, 0, 0, 0, 0, 1, 1, 0,1}, {
    0}
};
#endif /* _PHNX_INFO_H */
