/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#ifndef __IRQPARAM_H__
#define __IRQPARAM_H__

enum irq_call_e {
	NLM_REQUEST_IRQ = 1,
	NLM_FREE_IRQ,
	NLM_SET_IRQOPS,
};

enum irq_options_e {
	NLM_SET_STARTUP = 1,
	NLM_SET_SHUTDOWN,
	NLM_SET_EPIACK,
	NLM_SET_PROACK,
	NLM_SET_AFFINITY,
};

struct irq_param {
	int cmd;
	int rv; /* return value -1 or 0 */
	int err; /* detailed error number */
	int irq; /* irq number */
	unsigned long long handler;
	unsigned long long irqflags;
	unsigned long long mask;
	int options;
	int pad;
};

enum except_call_e {
	NLM_SET_EXCEPT_VECTOR = 1
};

struct except_param {
	int cmd;
	int rv;
	int index; /* exception index */
	int pad;
	unsigned long long handler;
};

#endif
