/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#ifndef __SHMPARAM_H__
#define __SHMPARAM_H__

#include <limits.h>
#include "hash.h"

#ifndef PATH_MAX
#define PATH_MAX 256
#endif /* PATH_MAX */

struct shm_open_entry {
	char name[PATH_MAX];
	void *mem;
	unsigned long long len;
	int refcnt; /* how many people are requested */
	int unlink; /* unlink request pending */
	spinlock_t lock;
	struct netl_hash_entry sentry;
};

enum shmcall_e {
	NETL_SHMOPEN_CALL = 1,
	NETL_SHMDESTROY_CALL,
	NETL_SHMUNLINK_CALL 
};

struct netl_shmopen {
	char name[PATH_MAX];
	int oflag;
	int mode;
	unsigned long long obj;
};

struct netl_shmdestroy {
	unsigned long long obj;
};

struct netl_shmunlink {
	char name[PATH_MAX];
};

struct netl_shmcall {
	int cmd;
	int rv; /* return value -1 or 0 */
	int err; /* detailed error number */
	union {
		struct netl_shmopen shmopen;
		struct netl_shmdestroy  shmdestroy;
		struct netl_shmunlink shmunlink;
	};
};

#endif
