/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _TYPES_H
#define _TYPES_H

#ifndef __ASSEMBLY__

#include <sys/types.h>
#include <stdint.h>

enum {FALSE = 0, TRUE = 1};

#if __LONG_MAX__ > 2147483647 || !defined(__GNUC__)
typedef unsigned long __kernel_size_t;
#else
typedef unsigned int __kernel_size_t;
#endif

typedef unsigned char __u8, u8;
//typedef signed char   int8_t;

//typedef __int16_t   int16_t;
//typedef __int32_t   int32_t;
//typedef __int64_t   int64_t;

typedef __uint16_t  __u16, u16;
typedef __uint32_t  __u32, u32;
typedef __uint64_t  __u64, u64;

# ifdef _ABI64
typedef unsigned long int __uintptr_t;
typedef long int __intptr_t;
# else
typedef __uint32_t __uintptr_t;
typedef __int32_t __intptr_t;
# endif

typedef __const char *c_caddr_t;    /* core address, pointer to const */
typedef __volatile char *v_caddr_t; /* core address, pointer to volatile */

typedef volatile uint32_t phoenix_reg_t;

#endif

#endif
