/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

// Lfsr based random generator
// Period 2^160
// Ahmed Shahid
// NLM

#include "rand_num.h"

unsigned long lfsr[5];

// seed random generator function
void rand_init() {
lfsr[0] = 0x04c11db7;
lfsr[1] = 0xa9d053d3;
lfsr[2] = 0xe50b9b1d;
lfsr[3] = 0x305a3b7c;
lfsr[4] = 0x64908b65;
}

// generate and return random numbers
unsigned long rand_gen() {
	int lsb;
    lsb = lfsr[4] & 1;
    lfsr[4] = ((lfsr[3] & 0x00000001) << 31) | (lfsr[4] >> 1);
    lfsr[3] = ((lfsr[2] & 0x00000001) << 31) | (lfsr[3] >> 1);
    lfsr[2] = ((lfsr[1] & 0x00000001) << 31) | (lfsr[2] >> 1);
    lfsr[1] = ((lfsr[0] & 0x00000001) << 31) | (lfsr[1] >> 1);
    lfsr[0] = lfsr[0] >> 1;
    if (lsb) {
    	lfsr[4] ^= MASK4;
    	lfsr[3] ^= MASK3;
    	lfsr[2] ^= MASK2;
    	lfsr[1] ^= MASK1;
		lfsr[0] ^= MASK0;
    }
	return lfsr[0];
}

// function to generate range of random values
unsigned long rand_range(int min, int max) {
unsigned long i;
i = (rand_gen() %(max-min)) + min; 
return (i);
}
