/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <unistd.h>
#include "libfdt.h"

void *read_dtb_file(char *dtbfname)
{
	FILE *img = NULL;
	long fsize;
	char *buf = NULL;

	if(!dtbfname)
		return NULL;

	/* Get the dtb file size Read the dtb file */
	img = fopen(dtbfname, "r");
	if (img == NULL) {
		fprintf(stderr, "File open error\n");
		return NULL;
	}
	fseek(img, 0, SEEK_END);
	if ((fsize = ftell(img)) <= 0) {
		fprintf(stderr, "Zero File size or seek err\n");
		goto err_exit;
	}

	if((buf = malloc(fsize + 32)) == NULL) {
		fprintf(stderr, "Malloc failed \n");
		goto err_exit;
	}

	fseek(img, 0, SEEK_SET);
	if((fread(buf, 1, fsize, img)) != fsize) {
		fprintf(stderr, "file read error\n");
		goto err_exit;
	}
	
	fclose(img);
	return buf;
err_exit:
	if(img)
		fclose(img);	
	if(buf)
		free(buf);

	return NULL;
}
