/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <netdevice.h>
#include <gmac.h>
#include <xgmac.h>
#include <spi4.h>

struct net_device gmac0_dev = {
	.name = "gmac0",
	.init = gmac0_init,
	.next = 0,
};

struct net_device gmac1_dev = {
	.name = "gmac1",
	.init = gmac1_init,
	.next = &gmac0_dev,
};

struct net_device gmac2_dev = {
	.name = "gmac2",
	.init = gmac2_init,
	.next = &gmac1_dev,
};

struct net_device gmac3_dev = {
	.name = "gmac3",
	.init = gmac3_init,
	.next = &gmac2_dev,
};

struct net_device gmac4_dev = {
        .name = "gmac4",
        .init = gmac4_init,
        .next = &gmac3_dev,
};

struct net_device gmac5_dev = {
        .name = "gmac5",
        .init = gmac5_init,
        .next = &gmac4_dev,
};

struct net_device gmac6_dev = {
        .name = "gmac6",
        .init = gmac6_init,
        .next = &gmac5_dev,
};

struct net_device gmac7_dev = {
        .name = "gmac7",
        .init = gmac7_init,
        .next = &gmac6_dev,
};

struct net_device xgmac0_dev = {
	.name = "xgmac0",
	.init = xgmac0_init,
	.next = &gmac7_dev,
};

struct net_device xgmac1_dev = {
	.name = "xgmac1",
	.init = xgmac1_init,
	.next = &xgmac0_dev,
};

struct net_device spi4_0_dev = {
	.name = "spi4_0",
	.init = spi4_0_init,
	.next = &xgmac1_dev,
};

struct net_device spi4_1_dev = {
	.name = "spi4_1",
	.init = spi4_1_init,
	.next = &spi4_0_dev,
};

struct net_device *netdevice_list = &spi4_1_dev;

struct net_device *dev_get_by_name(const char *name)
{
	struct net_device *dev = netdevice_list; 
	int i;
	
	for(dev = netdevice_list, i = 0; dev != 0; i++, dev=dev->next) {
		if (strcmp(dev->name, name)==0) {
		  return dev;
		}
	}
	printf ("%s, %s, %d, net_device %s not found\n", __FILE__, __FUNCTION__, __LINE__, name);
	return 0;
}

void register_netdev(struct net_device *dev)
{
	dev->next = netdevice_list;
	netdevice_list = dev;
}
