/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#include <stdlib.h>
#include <stdio.h>

static unsigned long tlb_page_size_list[] = {
	  2 << 20,
      8 << 20,      //   4 MB
     32 << 20,      //  16 MB
    128 << 20,      //  64 MB
    512 << 20       // 256 MB
};

int main(int argc, char **argv)
{
	unsigned long heapsize;
	unsigned long data_alignment;

	int  nelements, i;

	if (argc < 2) {
		return -1;
	}

	heapsize = strtoul(argv[1], NULL, 16);

	nelements = sizeof(tlb_page_size_list) / sizeof (tlb_page_size_list[0]);

	for (i = nelements - 1; (i > 0) && (heapsize < tlb_page_size_list[i]); --i)
		;
	printf ("0x%lx\n", tlb_page_size_list[i]);

	return 0;
}
