#ifndef _NLM_SOCLIB_H
#define _NLM_SOCLIB_H

#include <inttypes.h>

#ifdef _cplusplus
extern "C" {
#endif /* cplusplus */

struct nlm_soclib_timer {
	double start_cycles;
	double stop_cycles;
	double time_accum;
};

#define MAX_EVENTS 8
struct nlm_soclib_perfctr {
	int ctr[MAX_EVENTS];
	const char *ctr_name[MAX_EVENTS];
	int op;
	int thread;
	int global;
	int num_events;
	int started;
	uint64_t tmp_val[MAX_EVENTS];
	uint64_t ctr_val[MAX_EVENTS];
};

/* Init function */
extern void nlm_soclib_init(void);

/* Timer Functions */
extern void nlm_soclib_timer_init(struct nlm_soclib_timer *timer);
extern void nlm_soclib_timer_start(struct nlm_soclib_timer *timer);
extern void nlm_soclib_timer_stop(struct nlm_soclib_timer *timer);
extern double nlm_soclib_timer_seconds(const struct nlm_soclib_timer *timer);

/* Perfctr functions */
extern void nlm_soclib_perfctr_init(struct nlm_soclib_perfctr *pc);
extern void nlm_soclib_perfctr_start(struct nlm_soclib_perfctr *perfctr);
extern void nlm_soclib_perfctr_stop_accum(struct nlm_soclib_perfctr *perfctr);
extern void nlm_soclib_perfctr_print(struct nlm_soclib_perfctr *perfctr);

/* Environment functions */
extern void nlm_soclib_launch_cpus(void);

#ifdef _cplusplus
}
#endif /* cplusplus */

#endif /* _NLM_SOCLIB_H */
