#ifndef _PERF_CTR_H
#define _PERF_CTR_H

#ifdef NLM_ARCH_XLP

#define PERFCTR_INSN      24
#define PERFCTR_CYC       1
/* Below counters count Conditional branches and
 * corresponding mis-predicts
 */
#define PERFCTR_BR_MISS   28
#define PERFCTR_BR        27
/* Below counters count pipeline flushes on INT & EXC */
#define PERFCTR_INT       40
#define PERFCTR_EXC       39
/* L1_* only counts L1 data cache loads! */
#define PERFCTR_L1_HIT    48
#define PERFCTR_L1_REF    49
/* for global thread counting */
#define PERFCTR_GLOBAL    0

#else /* NLM_ARCH_XLP */

#define PERFCTR_INSN      17
#define PERFCTR_CYC       63
#define PERFCTR_BR_MISS   21
#define PERFCTR_BR        20
#define PERFCTR_INT       25
#define PERFCTR_EXC       26
#define PERFCTR_L1_HIT    38
#define PERFCTR_L1_REF    39
/* for global thread counting */
#define PERFCTR_GLOBAL    1

#endif /* NLM_ARCH_XLP */

#endif /* _PERF_CTR_H */
