/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright

    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _NLM_DEV_H
#define _NLM_DEV_H

/* Generic API */
extern int soc_recv(int vc, unsigned int *intf, uint64_t *paddr, unsigned int *flags);

/* NAE API */
enum nlm_nae_tx_flags {
	NLM_NAE_TX_NONE = 0,
	NLM_NAE_TX_FREE_IN = 0x1,
	NLM_NAE_HW_BUF_MGMT = 0x2,
};

enum nlm_nae_rx_flags {
	NLM_NAE_RX_NONE = 0,
	NLM_NAE_RX_ERR = 0x1,
	NLM_NAE_RX_TXC = 0x2,
	NLM_NAE_RX_TXERR = 0x4,
};

extern int nae_recv(uint64_t *paddr, unsigned int *cntl);
int nae_send(int dest, uint64_t paddr, int len, unsigned int flags);

/* DTR API */
int nlm_dtr_transfer (const char *in, uint32_t size, char *out);
int nlm_dtr_multi_transfer (const char **in, const unsigned int *len, char **out, unsigned int arr_size);
int nlm_dtr_raid (uint32_t disks, uint32_t segments_per_disk, char ***data,
                  const uint32_t *segment_length, uint32_t operation, uint32_t raidtype,
                  uint32_t p_device_id, uint32_t q_device_id);
/**/

#endif
